# Fractal sets

## How to calculate them

1. [Mandelbrot set](./mandelbrot.md)
2. [Julia set](./julia.md)

## Work proposals

Each student will have to propose either a parallel or pipelined architecture. For a given set, a student will have one or other of the requested architectures, but not both. This is to avoid duplicating projects.

### With the **Mandelbrot set**

> The formula is as follows:
>
>> $f(z)=z^{N}+C$
>
> With $N$ in the following power range:
>
>> 1. $N=2$
>> 2. $N=3$
>> 3. $N=4$
>> 4. $N=5$
>> 5. $N=6$
>> 6. $N=7$

![Mandelbrot sets](./img/mandelbrot.png)

### With the **Julia set**

> The formula is as follows:
>
>> $f(z)=z^{2}+C$
>
> With the following C values:
>
>> 1. $0.3 + 0.5\imath$
>> 2. $0.25 + 0.5\imath$
>> 3. $0.285 + 0.02\imath$

![Squared reciprocal Julia sets](./img/squared.png)

### With the **squared reciprocal Julia set**

> The formula is as follows:
>
>> $f(z)=\frac{1}{z^{2}}+C$
>
> With the following C values:
>
>> 1. $0.3 + 0.4\imath$
>> 2. $-0.8 + 0.6\imath$
>> 3. $0.5 + 0.1\imath$

![Squared reciprocal Julia sets](./img/squared_reciprocal.png)

# Game of Life with **high-speed links**

## How to calculate them

1. [Game of Life](./gol.md)

## Work proposals

An alternative is to implement a **Game of Life** where the game board is on two boards with two screens. The boards communicate through high-speed serial links.

![GOL](./img/gol.png)
